package com.hfkj.dao;

import com.hfkj.entity.BsMerPlatformTerm;
import com.hfkj.entity.BsMerPlatformTermExample.Criteria;
import com.hfkj.entity.BsMerPlatformTermExample.Criterion;
import com.hfkj.entity.BsMerPlatformTermExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsMerPlatformTermSqlProvider {

    public String countByExample(BsMerPlatformTermExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_mer_platform_term");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsMerPlatformTermExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_mer_platform_term");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsMerPlatformTerm record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_mer_platform_term");
        
        if (record.getMerPlatformNoId() != null) {
            sql.VALUES("mer_platform_no_id", "#{merPlatformNoId,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getActiveNo() != null) {
            sql.VALUES("active_no", "#{activeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getBusiTypeCode() != null) {
            sql.VALUES("busi_type_code", "#{busiTypeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getBusiTypeName() != null) {
            sql.VALUES("busi_type_name", "#{busiTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductCode() != null) {
            sql.VALUES("product_code", "#{productCode,jdbcType=VARCHAR}");
        }
        
        if (record.getProductName() != null) {
            sql.VALUES("product_name", "#{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getShopId() != null) {
            sql.VALUES("shop_id", "#{shopId,jdbcType=VARCHAR}");
        }
        
        if (record.getTermId() != null) {
            sql.VALUES("term_id", "#{termId,jdbcType=VARCHAR}");
        }
        
        if (record.getTermNo() != null) {
            sql.VALUES("term_no", "#{termNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsMerPlatformTermExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("mer_platform_no_id");
        sql.SELECT("mer_id");
        sql.SELECT("active_no");
        sql.SELECT("busi_type_code");
        sql.SELECT("busi_type_name");
        sql.SELECT("product_code");
        sql.SELECT("product_name");
        sql.SELECT("shop_id");
        sql.SELECT("term_id");
        sql.SELECT("term_no");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_mer_platform_term");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsMerPlatformTerm record = (BsMerPlatformTerm) parameter.get("record");
        BsMerPlatformTermExample example = (BsMerPlatformTermExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_platform_term");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getMerPlatformNoId() != null) {
            sql.SET("mer_platform_no_id = #{record.merPlatformNoId,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getActiveNo() != null) {
            sql.SET("active_no = #{record.activeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getBusiTypeCode() != null) {
            sql.SET("busi_type_code = #{record.busiTypeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getBusiTypeName() != null) {
            sql.SET("busi_type_name = #{record.busiTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductCode() != null) {
            sql.SET("product_code = #{record.productCode,jdbcType=VARCHAR}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        }
        
        if (record.getShopId() != null) {
            sql.SET("shop_id = #{record.shopId,jdbcType=VARCHAR}");
        }
        
        if (record.getTermId() != null) {
            sql.SET("term_id = #{record.termId,jdbcType=VARCHAR}");
        }
        
        if (record.getTermNo() != null) {
            sql.SET("term_no = #{record.termNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_platform_term");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("mer_platform_no_id = #{record.merPlatformNoId,jdbcType=BIGINT}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("active_no = #{record.activeNo,jdbcType=VARCHAR}");
        sql.SET("busi_type_code = #{record.busiTypeCode,jdbcType=VARCHAR}");
        sql.SET("busi_type_name = #{record.busiTypeName,jdbcType=VARCHAR}");
        sql.SET("product_code = #{record.productCode,jdbcType=VARCHAR}");
        sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        sql.SET("shop_id = #{record.shopId,jdbcType=VARCHAR}");
        sql.SET("term_id = #{record.termId,jdbcType=VARCHAR}");
        sql.SET("term_no = #{record.termNo,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsMerPlatformTermExample example = (BsMerPlatformTermExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsMerPlatformTerm record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_platform_term");
        
        if (record.getMerPlatformNoId() != null) {
            sql.SET("mer_platform_no_id = #{merPlatformNoId,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getActiveNo() != null) {
            sql.SET("active_no = #{activeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getBusiTypeCode() != null) {
            sql.SET("busi_type_code = #{busiTypeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getBusiTypeName() != null) {
            sql.SET("busi_type_name = #{busiTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductCode() != null) {
            sql.SET("product_code = #{productCode,jdbcType=VARCHAR}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getShopId() != null) {
            sql.SET("shop_id = #{shopId,jdbcType=VARCHAR}");
        }
        
        if (record.getTermId() != null) {
            sql.SET("term_id = #{termId,jdbcType=VARCHAR}");
        }
        
        if (record.getTermNo() != null) {
            sql.SET("term_no = #{termNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsMerPlatformTermExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}